"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StyledAction = exports.StyledFilterFooter = exports.StyledFilterHeading = exports.StyledFilterContent = exports.StyledFilterButton = exports.StyledCell = exports.StyledRow = exports.StyledBody = exports.StyledSortableLabel = exports.StyledHeadCell = exports.StyledHead = exports.StyledTable = void 0;

var _index = require("../styles/index.js");

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var StyledTable = (0, _index.styled)('div', function (_ref) {
  var $theme = _ref.$theme;
  return _objectSpread({}, $theme.borders.border300, {
    borderRadius: $theme.borders.radius200,
    display: 'flex',
    flexDirection: 'column',
    height: '100%',
    overflowX: 'scroll'
  });
});
exports.StyledTable = StyledTable;
StyledTable.displayName = "StyledTable";
var StyledHead = (0, _index.styled)('div', function (_ref2) {
  var $theme = _ref2.$theme,
      $width = _ref2.$width;
  return {
    backgroundColor: $theme.colors.tableHeadBackgroundColor,
    boxShadow: $theme.lighting.shadow400,
    display: 'flex',
    flexGrow: 0,
    width: $width ? $width : '100%',
    zIndex: 1
  };
});
exports.StyledHead = StyledHead;
StyledHead.displayName = "StyledHead";
var StyledHeadCell = (0, _index.styled)('div', function (_ref3) {
  var $theme = _ref3.$theme;
  return _objectSpread({}, $theme.typography.font350, $theme.borders.border300, {
    borderTop: 'none',
    borderBottom: 'none',
    borderLeft: 'none',
    display: 'flex',
    justifyContent: 'space-between',
    paddingTop: $theme.sizing.scale500,
    paddingRight: $theme.sizing.scale600,
    paddingBottom: $theme.sizing.scale500,
    paddingLeft: $theme.sizing.scale600,
    width: '100%',
    ':last-of-type': {
      borderRight: 'none'
    }
  });
});
exports.StyledHeadCell = StyledHeadCell;
StyledHeadCell.displayName = "StyledHeadCell";
var StyledSortableLabel = (0, _index.styled)('button', function (_ref4) {
  var $theme = _ref4.$theme;
  return _objectSpread({}, $theme.typography.font350, {
    alignItems: 'center',
    border: 'none',
    display: 'flex',
    padding: 0,
    ':hover:enabled': {
      cursor: 'pointer'
    },
    ':disabled': {
      color: $theme.colors.mono500
    }
  });
});
exports.StyledSortableLabel = StyledSortableLabel;
StyledSortableLabel.displayName = "StyledSortableLabel";
var StyledBody = (0, _index.styled)('div', function (_ref5) {
  var $width = _ref5.$width;
  return {
    width: $width ? $width : '100%',
    overflowX: 'hidden',
    overflowY: 'overlay',
    flex: 1
  };
});
exports.StyledBody = StyledBody;
StyledBody.displayName = "StyledBody";
var StyledRow = (0, _index.styled)('div', function (_ref6) {
  var $theme = _ref6.$theme;
  return {
    display: 'flex',
    alignItems: 'center'
  };
});
exports.StyledRow = StyledRow;
StyledRow.displayName = "StyledRow";
var StyledCell = (0, _index.styled)('div', function (_ref7) {
  var $theme = _ref7.$theme;
  return _objectSpread({}, $theme.typography.font300, {
    display: 'flex',
    flex: 1,
    paddingTop: $theme.sizing.scale300,
    paddingRight: $theme.sizing.scale600,
    paddingBottom: $theme.sizing.scale300,
    paddingLeft: $theme.sizing.scale600
  });
});
exports.StyledCell = StyledCell;
StyledCell.displayName = "StyledCell";
var StyledFilterButton = (0, _index.styled)('button', {
  border: 'none',
  padding: 'none'
});
exports.StyledFilterButton = StyledFilterButton;
StyledFilterButton.displayName = "StyledFilterButton";
var StyledFilterContent = (0, _index.styled)('div', function (_ref8) {
  var $theme = _ref8.$theme;
  return _objectSpread({}, $theme.borders.border300, {
    borderRight: 'none',
    borderLeft: 'none',
    maxHeight: '196px',
    paddingRight: $theme.sizing.scale600,
    paddingLeft: $theme.sizing.scale600,
    overflow: 'auto'
  });
});
exports.StyledFilterContent = StyledFilterContent;
StyledFilterContent.displayName = "StyledFilterContent";
var StyledFilterHeading = (0, _index.styled)('div', function (_ref9) {
  var $theme = _ref9.$theme;
  return _objectSpread({}, $theme.typography.font350, {
    color: $theme.colors.mono700,
    paddingTop: $theme.sizing.scale500,
    paddingRight: $theme.sizing.scale600,
    paddingBottom: $theme.sizing.scale500,
    paddingLeft: $theme.sizing.scale600
  });
});
exports.StyledFilterHeading = StyledFilterHeading;
StyledFilterHeading.displayName = "StyledFilterHeading";
var StyledFilterFooter = (0, _index.styled)('div', function (_ref10) {
  var $theme = _ref10.$theme;
  return {
    backgroundColor: $theme.colors.mono200,
    paddingTop: $theme.sizing.scale300,
    paddingRight: $theme.sizing.scale100,
    paddingBottom: $theme.sizing.scale300,
    paddingLeft: $theme.sizing.scale100,
    display: 'flex',
    justifyContent: 'space-between',
    width: '216px'
  };
});
exports.StyledFilterFooter = StyledFilterFooter;
StyledFilterFooter.displayName = "StyledFilterFooter";
var StyledAction = (0, _index.styled)('button', function (_ref11) {
  var $theme = _ref11.$theme;
  return {
    border: 'none',
    color: $theme.colors.primary,
    paddingTop: 0,
    paddingRight: 0,
    paddingBottom: 0,
    paddingLeft: 0,
    marginRight: $theme.sizing.scale100,
    marginLeft: $theme.sizing.scale100,
    ':hover:enabled': {
      cursor: 'pointer'
    }
  };
});
exports.StyledAction = StyledAction;
StyledAction.displayName = "StyledAction";