"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _darkThemePrimitives = require("./dark-theme-primitives.js");

/*
Copyright (c) 2018 Uber Technologies, Inc.

This source code is licensed under the MIT license found in the
LICENSE file in the root directory of this source tree.
*/
var WHITE = '#FFFFFF';
var _default = {
  colors: {
    // Semantic Colors
    // Font Color
    colorPrimary: _darkThemePrimitives.primitives.mono100,
    colorSecondary: _darkThemePrimitives.primitives.mono200,
    // Background
    background: _darkThemePrimitives.primitives.mono800,
    backgroundAlt: _darkThemePrimitives.primitives.mono700,
    backgroundInv: _darkThemePrimitives.primitives.mono100,
    // Foreground
    foreground: _darkThemePrimitives.primitives.mono100,
    foregroundAlt: _darkThemePrimitives.primitives.mono300,
    foregroundInv: _darkThemePrimitives.primitives.mono1000,
    // Borders
    border: _darkThemePrimitives.primitives.mono600,
    borderAlt: _darkThemePrimitives.primitives.mono700,
    borderFocus: _darkThemePrimitives.primitives.primary400,
    borderError: _darkThemePrimitives.primitives.negative400,
    // Buttons
    buttonPrimaryFill: _darkThemePrimitives.primitives.primary400,
    buttonPrimaryText: '#FFFFFF',
    buttonPrimaryHover: _darkThemePrimitives.primitives.primary500,
    buttonPrimaryActive: _darkThemePrimitives.primitives.primary600,
    buttonSecondaryFill: _darkThemePrimitives.primitives.mono500,
    buttonSecondaryText: _darkThemePrimitives.primitives.mono100,
    buttonSecondaryHover: _darkThemePrimitives.primitives.mono400,
    buttonSecondaryActive: _darkThemePrimitives.primitives.mono300,
    buttonTertiaryFill: _darkThemePrimitives.primitives.mono700,
    buttonTertiaryText: _darkThemePrimitives.primitives.mono100,
    buttonTertiaryHover: _darkThemePrimitives.primitives.mono600,
    buttonTertiaryActive: _darkThemePrimitives.primitives.mono500,
    buttonTertiarySelectedText: _darkThemePrimitives.primitives.mono100,
    buttonTertiarySelectedFill: _darkThemePrimitives.primitives.primary400,
    buttonMinimalFill: 'transparent',
    buttonMinimalText: _darkThemePrimitives.primitives.primary400,
    buttonMinimalHover: _darkThemePrimitives.primitives.mono600,
    buttonMinimalActive: _darkThemePrimitives.primitives.mono500,
    buttonDisabledFill: _darkThemePrimitives.primitives.mono700,
    buttonDisabledText: _darkThemePrimitives.primitives.mono500,
    // Breadcrumbs
    breadcrumbsText: _darkThemePrimitives.primitives.mono100,
    breadcrumbsSeparatorFill: _darkThemePrimitives.primitives.mono200,
    // FileUploader
    fileUploaderBackgroundColor: _darkThemePrimitives.primitives.mono700,
    fileUploaderBackgroundColorActive: _darkThemePrimitives.primitives.mono600,
    fileUploaderBorderColorActive: _darkThemePrimitives.primitives.primary400,
    fileUploaderBorderColorDefault: _darkThemePrimitives.primitives.mono500,
    fileUploaderMessageColor: _darkThemePrimitives.primitives.mono100,
    // Links
    linkText: _darkThemePrimitives.primitives.primary300,
    linkVisited: _darkThemePrimitives.primitives.primary300,
    linkHover: _darkThemePrimitives.primitives.primary400,
    // List
    listHeaderFill: _darkThemePrimitives.primitives.mono600,
    listBodyFill: _darkThemePrimitives.primitives.mono700,
    listIconFill: _darkThemePrimitives.primitives.mono100,
    listBorder: _darkThemePrimitives.primitives.mono500,
    // Tag
    tagBackground: _darkThemePrimitives.primitives.mono1000,
    tagNeutralBackground: _darkThemePrimitives.primitives.mono600,
    tagPrimaryBackground: _darkThemePrimitives.primitives.primary500,
    tagPositiveBackground: _darkThemePrimitives.primitives.positive500,
    tagWarningBackground: _darkThemePrimitives.primitives.warning500,
    tagNegativeBackground: _darkThemePrimitives.primitives.negative500,
    // Tick
    tickFill: 'transparent',
    tickFillHover: _darkThemePrimitives.primitives.mono200,
    tickFillActive: _darkThemePrimitives.primitives.mono300,
    tickFillSelected: _darkThemePrimitives.primitives.primary400,
    tickFillSelectedHover: _darkThemePrimitives.primitives.primary500,
    tickFillSelectedHoverActive: _darkThemePrimitives.primitives.primary600,
    tickFillDisabled: _darkThemePrimitives.primitives.mono600,
    tickBorder: _darkThemePrimitives.primitives.mono400,
    tickMarkFill: WHITE,
    // Slider
    sliderTrackFill: _darkThemePrimitives.primitives.mono500,
    sliderTrackFillHover: _darkThemePrimitives.primitives.mono600,
    sliderTrackFillActive: _darkThemePrimitives.primitives.mono700,
    sliderTrackFillSelected: _darkThemePrimitives.primitives.primary700,
    sliderTrackFillSelectedActive: _darkThemePrimitives.primitives.primary700,
    sliderTrackFillSelectedHover: _darkThemePrimitives.primitives.primary700,
    sliderTrackFillDisabled: _darkThemePrimitives.primitives.mono600,
    sliderHandleFill: _darkThemePrimitives.primitives.mono300,
    sliderHandleFillHover: _darkThemePrimitives.primitives.mono300,
    sliderHandleFillActive: _darkThemePrimitives.primitives.mono300,
    sliderHandleFillSelected: _darkThemePrimitives.primitives.primary500,
    sliderHandleFillSelectedHover: _darkThemePrimitives.primitives.primary600,
    sliderHandleFillSelectedActive: _darkThemePrimitives.primitives.primary700,
    sliderHandleFillDisabled: _darkThemePrimitives.primitives.mono600,
    sliderBorder: WHITE,
    sliderBorderHover: WHITE,
    sliderBorderDisabled: _darkThemePrimitives.primitives.mono400,
    // Input
    inputFill: _darkThemePrimitives.primitives.mono600,
    inputFillEnhancer: _darkThemePrimitives.primitives.mono500,
    inputFillError: _darkThemePrimitives.primitives.mono600,
    inputFillDisabled: _darkThemePrimitives.primitives.mono700,
    inputTextDisabled: _darkThemePrimitives.primitives.mono500,
    // Menu
    menuFillHover: _darkThemePrimitives.primitives.mono800,
    menuFontDefault: _darkThemePrimitives.primitives.mono400,
    menuFontDisabled: _darkThemePrimitives.primitives.mono500,
    menuFontHighlighted: _darkThemePrimitives.primitives.mono200,
    menuFontSelected: _darkThemePrimitives.primitives.mono200
  },
  tooltip: {
    backgroundColor: _darkThemePrimitives.primitives.mono200
  }
};
exports.default = _default;